--[[ autumn and spring script
Created by: birbhorse, aka EeveeEuphoria
Credits:
	- Ice Spring, Rock Shield, Mobj RingSpill: Me, since I made those.
	- Music: https://soundcloud.com/leila-wilson-woofle/312notaiz
		Act 2: https://music.ubiktune.com/track/taiga
	- Sonic the Hedgehog (Master System) - Sound and Sprites used for the broken ring monitor.
	- Pokemon X/Y - The Pi(ka)chu.

- autumn is windy, spring involves vines/growth/something like that 
when autumn comes, the vines decay


ideas:
pumpkin decorations
	- turn it into something else during spring? 

trees can be bumped into during autumn to remove leaves  

retool ice spring into autumn spring, one that breaks into many leaves 

RECOLOR TOOL: 87872B
USE DARKEST GREEN

palette colors 96–111 for skincolor stuff

use "special" flag for ring to make it bob up and down, to use in wind

TODO:
	- make leaf pile "respawn" after season change and it's been hit once
		- or don't 
	- 


idea: use wind to prohibit access to a place that is below, requires setting to spring in order to pass 
also make sure player knows it's safe to travel over these pits when it's not autumn 
	- make a cave hole that the player falls into, and they teleport to a different place
	- this place contains a pit they can safely float over, and at the other side of the room is the autumn switch, which the player has to press in order to travel back to a room that's near the hole they fell

idea for leaf pile: multiple objects to make it pseudo-3d, have them be paper sprites too 

move the pi(ka)chu room to the caves, uses a spin-bustable block where the ringbox currently is to enter

make leaf spawner object use "extra" to indicate an angle should be applied to the momentum using P_Thrust; 
the angle number is the object's Z mapthing position, not the absolute value but wherever it's set to in zone builder

]]--

local winterbeachteleport
local season = "spring"
local previousseason = "autumn"
local maploaded = false

local autrings = 0
local autringconfirm = false
local sprrings = 0
local sprringconfirm = false

local nonoise = false

freeslot(
"SPR_WBLE",
"S_LEAF",
"MT_FLOATINGLEAVES",

"MT_LEAFSPAWNER",

"MT_WBHOLOGRAM2",
"S_HOLOGRAMSPRING",
"S_HOLOGRAMAUTUMN",
"SPR_WBH2",

"S_AUTUMNGFZTREE",
"S_AUTUMNPINETREE",
"S_AUTUMNBLUEBERRYBUSH", "S_AUTUMNBERRYBUSH", "S_AUTUMNBUSH",

"sfx_sttb3",

"SPR_ASLP",
"S_LEAFPILE",
"MT_LEAFPILE",
"MT_LEAFDEBRIS",
"sfx_aslf",

"MT_AUTUMNSPRING", "S_AUTUMNSPRING", "S_AUTUMNSPRING2", "S_AUTUMNSPRING3", "S_AUTUMNSPRING4", "S_AUTUMNSPRING5", "S_AUTUMNSPRING6", "S_AUTUMNSPRING7", "S_AUTUMNSPRING8", "SPR_ASRG"
)

states[S_AUTUMNGFZTREE] = {SPR_WBT1, B, -1, nil, 0, 0, S_NULL}
states[S_AUTUMNPINETREE] = {SPR_WBPI, B, -1, nil, 0, 0, S_NULL}

states[S_AUTUMNBLUEBERRYBUSH] = {SPR_BUS3, C, -1, nil, 0, 0, S_NULL}
states[S_AUTUMNBERRYBUSH] = {SPR_BUS1, C, -1, nil, 0, 0, S_NULL}
states[S_AUTUMNBUSH] = {SPR_BUS2, C, -1, nil, 0, 0, S_NULL}

local function A_ChangeSeasons(actor, var1, var2)
	if season == "spring"
		P_LinedefExecute(26)
	else
		P_LinedefExecute(40)
	end
end

states[S_LEAF] = {
	sprite = SPR_WBLE,
	frame = A,
	tics = -1,
}

states[S_LEAFPILE] = {
	sprite = SPR_ASLP,
	frame = A,
	tics = -1,
}

mobjinfo[MT_LEAFSPAWNER] = {
	--$Name Rising Leaves
	--$Sprite WBLEA0
	--$Category winterbeach Objects
	doomednum = 4071,
	spawnstate = S_INVISIBLE,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_FLOATINGLEAVES] = {
	doomednum = -1,
	spawnstate = S_LEAF,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_LEAFDEBRIS] = {
	doomednum = -1,
	spawnstate = S_LEAF,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 20*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOCLIP
}

mobjinfo[MT_LEAFPILE] = {
	--$Name Leaf Pile
	--$Sprite ASLPA0
	--$Category winterbeach Objects
	doomednum = 4072,
	spawnstate = S_LEAFPILE,
	speed = 0,
	height = 15*FRACUNIT,
	radius = 32*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_SPECIAL
}

states[S_HOLOGRAMAUTUMN] = {
	sprite = SPR_WBH2,
	frame = FF_PAPERSPRITE|A,
	tics = -1,
}

states[S_HOLOGRAMSPRING] = {
	sprite = SPR_WBH2,
	frame = FF_PAPERSPRITE|B,
	tics = -1,
}

mobjinfo[MT_WBHOLOGRAM2] = {
	--$Name Season Hologram 2
	--$Sprite WBH2AL
	--$Category winterbeach Objects
	doomednum = 673,
	spawnstate = S_HOLOGRAMAUTUMN,
	speed = 0,
	height = 128*FRACUNIT,
	radius = 40*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP
}

addHook("MapLoad", function(map) if gamemap != 44 return end 

	winterbeachteleport = false
	season = "spring"
	previousseason = "spring"
	
end)

addHook("MapChange", function(map) if gamemap != 44 return end 

	autrings = 0
	sprrings = 0
	autringconfirm = false
	sprringconfirm = false
	
end)

addHook("LinedefExecute", function(buttonsmash, mo) if gamemap != 44 return end --local player = mo.player
	winterbeachteleport = true
	season = "autumn"
	print("LEAFY TIME")
	if season != previousseason
		if not nonoise
			S_StartSound(mo, sfx_s3k76)
			print("NOISE MADE AUTUMN")
		end
		for mapthing in mapthings.iterate do 
			if mapthing.type == mobjinfo[MT_WBWING].doomednum
				mapthing.mobj.ChangeSelf = true
			elseif mapthing.type == mobjinfo[MT_LEAFPILE].doomednum
				mapthing.mobj.touched = false
				mapthing.mobj.stopnow = false
			end
		end
	end
	
end, "BTNMSH")

addHook("LinedefExecute", function(buttonsmash, mo) if gamemap != 44 return end --local player = mo.player
	winterbeachteleport = true
	season = "spring"
	print("SPRING TIME AGAIN")
	if season != previousseason
		if not nonoise
			S_StartSound(mo, sfx_s3k76)
			print("NOISE MADE SPRING")
		end
		for mapthing in mapthings.iterate do
			if mapthing.type == mobjinfo[MT_WBWING].doomednum
				mapthing.mobj.ChangeSelf = true
			elseif mapthing.type == mobjinfo[MT_AUTUMNSPRING].doomednum
				mapthing.mobj.Ready = true
			elseif mapthing.type == mobjinfo[MT_LEAFPILE].doomednum
				mapthing.mobj.touched = true
			end
		end
	end
	
end, "BTNSUM")

addHook("ThinkFrame", function(buppon) if gamemap != 44 return end

	if leveltime > 10*TICRATE
		maploaded = true -- i know i should just do this directly, but shut up this was from older code and i'm lazy
	end

	if winterbeachteleport and season != previousseason
		print("lol horses")
		if season == "autumn"
		
			for sector in sectors.iterate do 
				if sector.floorpic == "GFZFLR02"
					sector.floorpic = "WBZFLR02"
				elseif sector.floorpic == "GFZFLR21"
					sector.floorpic = "WBZFLR21"				
				elseif sector.floorpic == "GFZCPY02"
					sector.floorpic = "WBZFLR03"				
				elseif sector.floorpic == "GFZCPY01"
					sector.floorpic = "WBZFLR04"
				elseif sector.floorpic == "CHKGRASF"
					sector.floorpic = "CHKGWBZF"
				end
				if sector.ceilingpic == "GFZFLR02"
					sector.ceilingpic = "WBZFLR02"
				elseif sector.ceilingpic == "GFZFLR21"
					sector.ceilingpic = "WBZFLR21"
				elseif sector.ceilingpic == "GFZCPY02"
					sector.ceilingpic = "WBZFLR03"				
				elseif sector.ceilingpic == "GFZCPY01"
					sector.ceilingpic = "WBZFLR04"
				elseif sector.ceilingpic == "CHKGRASF"
					sector.ceilingpic = "CHKGWBZF"
				end
			end
			
			for mapthing in mapthings.iterate do -- raise autumn emblem
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 6 and mapthing.mobj
						mapthing.mobj.z = 1072*FRACUNIT
					end
				end
			end
			
			
		else
			for sector in sectors.iterate do 
				if sector.floorpic == "WBZFLR02"
					sector.floorpic = "GFZFLR02"
				elseif sector.floorpic == "WBZFLR21"
					sector.floorpic = "GFZFLR21"
				elseif sector.floorpic == "WBZFLR03"
					sector.floorpic = "GFZCPY02"			
				elseif sector.floorpic == "WBZFLR04"
					sector.floorpic = "GFZCPY01"
				elseif sector.floorpic == "CHKGWBZF"
					sector.floorpic = "CHKGRASF"
				end
				if sector.ceilingpic == "WBZFLR02"
					sector.ceilingpic = "GFZFLR02"
				elseif sector.ceilingpic == "WBZFLR21"
					sector.ceilingpic = "GFZFLR21"
				elseif sector.ceilingpic == "WBZFLR03"
					sector.ceilingpic = "GFZCPY02"				
				elseif sector.ceilingpic == "WBZFLR04"
					sector.ceilingpic = "GFZCPY01"
				elseif sector.ceilingpic == "CHKGWBZF"
					sector.ceilingpic = "CHKGRASF"
				end
			end
		end
		
		for mapthing in mapthings.iterate do -- lower autumn emblem
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 6 and mapthing.mobj
						mapthing.mobj.z = 920*FRACUNIT
					end
				end
			end
		
		
		winterbeachteleport = false
		previousseason = season
		
		if not nonoise
			for player in players.iterate do
				P_FlashPal(player, PAL_WHITE, (TICRATE/3))
			end
		end
	end
	
	if maploaded -- just to make sure these don't get set off before the values have actually been set 
		if autrings == 0 and not autringconfirm
			print("fall crab")
			autringconfirm = true
			P_LinedefExecute(150) -- raises platform to give emblem
			for mapthing in mapthings.iterate do
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 1 and mapthing.mobj
						mapthing.mobj.z = $ + 152*FRACUNIT
						print("changed z for autumn")
					end
				end
			end
			
			
			-- MAKE HUD THAT SHOWS UP FOR A FEW SECONDS, NOTIFYING PLAYER OF ACCOMPLISHMENT
		end
		
		if sprrings == 0 and not sprringconfirm
			print("spring crab")
			P_LinedefExecute(151) -- raises platform to give emblem
			sprringconfirm = true
			for mapthing in mapthings.iterate do
				if mapthing.type == mobjinfo[MT_EMBLEM].doomednum
					if mapthing.angle == 2 and mapthing.mobj
						mapthing.mobj.z = $ + 152*FRACUNIT
						print("changed z for spring")
					end
				end
			end
		end
	end
	
	
end)


addHook("PlayerThink", function(player) if gamemap != 44 or netgame return end player.wbztimer = $ + 1

	if player.starpostnum and (player.CheckpointSeasonSet != player.starpostnum) -- be sure to change if there's more than 1 checkpoint
		player.CheckpointSeason = season
		player.CheckpointSeasonSet = player.starpostnum
		print("set season: " .. player.CheckpointSeason)
	end

	if player.JustRespawned 
		if player.CheckpointSeason == "autumn"
			player.ChangeSeason = true
			print("change season confirm")
		end
		player.JustRespawned = false
	end
	
	--[[if player.playerstate == PST_REBORN
		print("REBORN")
	end]]
	
	if player.ChangeSeason and player.playerstate == PST_LIVE and player.wbztimer > 5
		print("change season")
		A_ChangeSeasons(true)
		nonoise = true
		player.ChangeSeason = false
		player.StopNoNoise = true
	end
	
	if player.StopNoNoise and player.wbztimer > 3*TICRATE
		nonoise = false
		print("NO NOISE OFF")
		player.StopNoNoise = false
	end

	if (player.cmd.buttons & BT_CUSTOM1)
		print("autumn rings: " .. autrings)
		print("spring rings: " .. sprrings)
	end

end)

addHook("PlayerSpawn", function(player) if gamemap != 44 or netgame return end
	player.wbztimer = 0
	player.CheckpointSeasonSet = 0
	if not player.CheckpointSeason
		player.CheckpointSeason = "spring"
	end
	
	player.JustRespawned = true
end)

addHook("MobjThinker", function(ring) if gamemap != 44 return end -- create internal timer used to reset frame to correct time, FF_ANIMATE|TR_TRANS40
	if not ring.shadowscale and ring.health
		ring.ChangeSelf = true
		ring.shadowscale = 2*FRACUNIT/3 
		if ring.spring
			ring.color = SKINCOLOR_EMERALD
			sprrings = $ + 1
		else
			ring.color = SKINCOLOR_RUST
			autrings = $ + 1	
		end
	end 
	
	--[[if autumnbeachteleport --used to work, until i changed everything to use continous on the map
		ring.ChangeSelf = true
		print("change")
	end]]
	
	
	if ring.ChangeSelf and (ring.state == S_WBWING or ring.state == S_WBWINGNO) and leveltime > TICRATE 
		if ring.autumn and season == "spring"
			ring.state = S_WBWINGNO
		elseif ring.spring and season == "autumn"
			ring.state = S_WBWINGNO
		elseif ring.state != S_WBWING
			ring.state = S_WBWING
		end
	ring.ChangeSelf = false
	end

end, MT_WBWING)

addHook("TouchSpecial", function(ring, playermobj) if gamemap != 44 return end
	if ring.state == S_WBWING
		P_GivePlayerRings(playermobj.player, 1)
		if ring.spring
			sprrings = $ - 1
		else
			autrings = $ - 1
		end
		if playermobj.player.bot == 0
			return false
		else
			P_KillMobj(ring)
			return true
		end
	else
		return true
	end
end, MT_WBWING)


local function ChooseAutumnColor(color)
	local RNGTIME = P_RandomRange(1, 9)
	if RNGTIME == 1
		return SKINCOLOR_YELLOW
	elseif RNGTIME == 2
		return SKINCOLOR_ORANGE
	elseif RNGTIME == 3
		return SKINCOLOR_COPPER
	elseif RNGTIME == 4
		return SKINCOLOR_PEACHY
	elseif RNGTIME == 5
		return SKINCOLOR_CRIMSON
	elseif RNGTIME == 6
		return SKINCOLOR_QUAIL
	elseif RNGTIME == 7
		return SKINCOLOR_SANDY
	elseif RNGTIME == 8
		return SKINCOLOR_GOLD
	else
		return SKINCOLOR_APRICOT
	end

end

local function GiveTimer(mapthing) 
	mapthing.timer = 0
end

addHook("MapThingSpawn", GiveTimer, MT_LEAFSPAWNER)


addHook("MapThingSpawn", function(leafeon, mapthing)
	--35
	
	if mapthing.options & MTF_EXTRA
		leafeon.addedmom = mapthing.z
		mapthing.z = 0
	end

end, MT_LEAFSPAWNER)

addHook("MapThingSpawn", function(ring, mapthing) if gamemap != 44 return end
	if mapthing.options & MTF_AMBUSH
		ring.z = $ + (24*FRACUNIT)
	end
	
	ring.timer = 0 
	
	if mapthing.options & MTF_EXTRA
		ring.autumn = true
	else
		ring.spring = true
	end
	
end, MT_WBWING)


addHook("MobjThinker", function(leafeon)
	if season == "autumn"
		if (leafeon.timer % (2*TICRATE + TICRATE/2) == 0) or (leafeon.timer <= 1)
			S_StartSound(leafeon, sfx_s3kcel)
		end
		leafeon.timer = $ + 1
	else
		leafeon.timer = 1
	end
	--print(leafeon.timer)
	
	if leafeon.timer % (TICRATE/5) == 0 -- every 5 tics on the timer 
		local MOMX = P_RandomRange(-2, 2) * FRACUNIT
		local MOMY = P_RandomRange(-2, 2) * FRACUNIT
		local MOMZ = P_RandomRange(5, 8) * FRACUNIT
		local POSITIONX = leafeon.x + (P_RandomRange(-30, 38)*FRACUNIT)
		local POSITIONY = leafeon.y + (P_RandomRange(-30, 38)*FRACUNIT)
		local POSITIONZ = leafeon.z+ (P_RandomRange(-5, 8)*FRACUNIT)
		local FUSE = (leafeon.angle/ANG1) + P_RandomRange(4, 15)
		local SCALE = FRACUNIT-(FRACUNIT/P_RandomRange(2, 5))
		local COLOR = ChooseAutumnColor()
		local ROTATION = 20 * ANG1
		local FLIP = false
		
		if (leafeon.flags2 & MF2_OBJECTFLIP)
			MOMZ = -$
			FLIP = true
		end
	

		local leaf = P_SpawnMobj(POSITIONX, POSITIONY, POSITIONZ, MT_FLOATINGLEAVES)
		leaf.momx = MOMX
		leaf.momy = MOMY
		leaf.momz = MOMZ
		if leafeon.addedmom
			local THRUSTER = P_RandomRange(((leafeon.angle/ANG1)/9), ((leafeon.angle/ANG1)/8)) * FRACUNIT
			P_Thrust(leaf, (leafeon.addedmom*ANG1), THRUSTER)
		end
		leaf.expire = FUSE
		leaf.scale = SCALE
		leaf.color = COLOR
		leaf.timer = 1
		leaf.transstate = 0
		leaf.rotation = ROTATION
		leaf.rotate = true
		
		if FLIP
			leaf.flipout = true
			leaf.flags2 = $ & MF2_OBJECTFLIP
		end
		--print("spawn " .. leafeon.timer)
	end


end, MT_LEAFSPAWNER)


addHook("MobjThinker", function(hologram) if gamemap != 44 return end -- have this pulsate it's transparency, from 30 to 60
	if not hologram.setsprite 
		if hologram.angle > ANG15
			hologram.state = S_HOLOGRAMSPRING
		end
		hologram.angle = 0
		hologram.setsprite = true
	end
	
	if hologram.state == S_HOLOGRAMAUTUMN
		if season == "spring"
			hologram.angle = $ + FixedAngle(5<<FRACBITS)
		else
			hologram.angle = $ + ANG2
		end
	else
		if season == "autumn"
			hologram.angle = $ + FixedAngle(5<<FRACBITS)
		else
			hologram.angle = $ + ANG2
		end
	end

end, MT_WBHOLOGRAM2)


local function lettuce(leaf)

	leaf.expire = $ - 1
	
	if leaf.expire < 0
		leaf.timer = $ + 1
	end

	local function RestoreState()
		leaf.state = S_LEAF
	end
	
	if leaf.rotate
		leaf.rollangle = $ + leaf.rotation
		if leaf.rotation > 0
			leaf.rotation = $ - (ANG1/5)
		else
			leaf.rotation = 0
		end
	end

	if (leaf.timer % 3) == 0 --stolen from my rockshield script, for it is highly useful
		leaf.transstate = $ + 1
	end
	
	if leaf.transstate == 1
		RestoreState()
		leaf.frame = $1 | TR_TRANS10
	elseif leaf.transstate == 2
		RestoreState()
		leaf.frame = $1 | TR_TRANS20
	elseif leaf.transstate == 3
		RestoreState()
		leaf.frame = $1 | TR_TRANS30
	elseif leaf.transstate == 4
		RestoreState()
		leaf.frame = $1 | TR_TRANS40
	elseif leaf.transstate == 5
		RestoreState()
		leaf.frame = $1 | TR_TRANS50
	elseif leaf.transstate == 6
		RestoreState()
		leaf.frame = $1 | TR_TRANS60
	elseif leaf.transstate == 7
		RestoreState()
		leaf.frame = $1 | TR_TRANS70
	elseif leaf.transstate == 8
		RestoreState()
		leaf.frame = $1 | TR_TRANS80
	elseif leaf.transstate == 9
		RestoreState()
		leaf.frame = $1 | TR_TRANS90
	elseif leaf.transstate >= 10
		P_RemoveMobj(leaf)
		return
	end

end

addHook("MobjThinker", lettuce, MT_FLOATINGLEAVES)
addHook("MobjThinker", lettuce, MT_LEAFDEBRIS)

addHook("MobjThinker", function(pile) --if not pile.timerz pile.timerz = 0 end

	local function CreateLeaf() -- add rotation
			local MOMX = P_RandomRange(-2, 2) * FRACUNIT
			local MOMY = P_RandomRange(-2, 2) * FRACUNIT
			local MOMZ = P_RandomRange(5, 8) * FRACUNIT
			local POSITIONX = pile.x + (P_RandomRange(-30, 38)*FRACUNIT)
			local POSITIONY = pile.y + (P_RandomRange(-30, 38)*FRACUNIT)
			local POSITIONZ = pile.z+ (P_RandomRange(-5, 8)*FRACUNIT)
			local FUSE = (pile.angle/ANG1) - P_RandomRange(4, 15)
			local SCALE = FRACUNIT-(FRACUNIT/P_RandomRange(2, 5))
			local COLOR = ChooseAutumnColor()
			local ROTATION = P_RandomRange(5, 14) * ANG1

			local leaf = P_SpawnMobj(POSITIONX, POSITIONY, POSITIONZ, MT_LEAFDEBRIS)
			leaf.momx = MOMX
			leaf.momy = MOMY
			leaf.momz = MOMZ
			leaf.expire = FUSE
			leaf.scale = SCALE
			leaf.color = COLOR
			leaf.timer = 1
			leaf.transstate = 0
			leaf.rotation = ROTATION
			leaf.rotate = true
	end
	
	
	if season != "autumn"
		pile.state = S_INVISIBLE
	elseif not pile.touched
		pile.state = mobjinfo[MT_LEAFPILE].spawnstate
	end
	
	if pile.touched and not pile.stopnow
		pile.state = S_INVISIBLE
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		CreateLeaf()
		pile.stopnow = true
	end
	

end, MT_LEAFPILE)

addHook("TouchSpecial", function(pile, playermobj) if gamemap != 44 return end
	if pile.state == S_LEAFPILE
		pile.touched = true
		S_StartSound(pile, sfx_aslf)
		return true
	else
		return true
	end
end, MT_LEAFPILE)

--scenery change

local function leafcovered(mobj) if gamemap != 44 return end
	if season == "autumn" and not mobj.changedtype
		if mobj.type == MT_BUSH 
			mobj.state = S_AUTUMNBUSH
		elseif mobj.type == MT_BERRYBUSH 
			mobj.state = S_AUTUMNBERRYBUSH
		elseif mobj.type == MT_BLUEBERRYBUSH
			mobj.state = S_AUTUMNBLUEBERRYBUSH
		elseif mobj.type == MT_GFZTREE
			mobj.state = S_AUTUMNGFZTREE		
		elseif mobj.type == MT_PINETREE
			mobj.state = S_AUTUMNPINETREE
		end
		mobj.changedtype = true
		return true
	elseif season == "spring" and mobj.changedtype
		mobj.state = mobj.info.spawnstate
		mobj.changedtype = false
		return false
	end

end

addHook("MobjThinker", leafcovered, MT_BUSH)
addHook("MobjThinker", leafcovered, MT_BLUEBERRYBUSH)
addHook("MobjThinker", leafcovered, MT_BERRYBUSH)
addHook("MobjThinker", leafcovered, MT_GFZTREE)
addHook("MobjThinker", leafcovered, MT_PINETREE)


mobjinfo[MT_AUTUMNSPRING] = {
		--$Name Autumn Spring
		--$Sprite ASRGA0
		--$Category Springs and Fans
		
		doomednum = 3070,							-- REPLACE ME!!
		spawnstate = S_AUTUMNSPRING,
		seestate = S_AUTUMNSPRING2,
		seesound = sfx_None,
		attacksound = sfx_None,
		painstate = S_NULL,
		painsound = sfx_s1cc,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_NULL,
		xdeathstate = S_NULL,
		deathsound = sfx_None,
		activesound = sfx_aslf,
		raisestate = S_AUTUMNSPRING2,
		spawnhealth = 1000,
		reactiontime = 0, -- undocumented, but changing this to 0 prevents it from giving points. why the hell isn't this documented?
		painchance = 7,							-- Respawn timer, in seconds
		speed = 0,
		radius = 20*FRACUNIT,
		height = 16*FRACUNIT,
		dispoffset = 0,
		mass = 17*FRACUNIT,							-- Used for the strength of the spring, for reference: Red (32), Yellow (20), Blue (11)
		damage = 0,
		flags = MF_SOLID|MF_SPRING
	}

mobjinfo[MT_ICESHRAPNEL] = {
	doomednum = -1,
	spawnstate = S_ICESHRAP,
	height = 5*FRACUNIT,
	radius = 5*FRACUNIT,
	flags = MF_BOUNCE|MF_NOCLIPTHING
}

states[S_AUTUMNSPRING] = {SPR_ASRG, A, -1, nil, 0, 0, S_NULL}
states[S_AUTUMNSPRING2] = {SPR_ASRG, B, 4, A_Pain, 0, 0, S_AUTUMNSPRING3}
states[S_AUTUMNSPRING3] = {SPR_ASRG, C, 2, nil, 0, 0, S_AUTUMNSPRING4}
states[S_AUTUMNSPRING4] = {SPR_ASRG, D, 2, nil, 0, 0, S_AUTUMNSPRING5}
states[S_AUTUMNSPRING5] = {SPR_ASRG, E, 2, nil, 0, 0, S_AUTUMNSPRING6}
states[S_AUTUMNSPRING6] = {SPR_ASRG, F, 2, nil, 0, 0, S_AUTUMNSPRING7}
states[S_AUTUMNSPRING7] = {SPR_ASRG, G, 2, nil, 0, 0, S_AUTUMNSPRING8}
states[S_AUTUMNSPRING8] = {SPR_ASRG, H, 2, A_PlayActiveSound, 0, 0, S_INVISIBLE}

addHook("MobjThinker", function(spring) if gamemap != 44 return end
	local function CreateLeaf() -- add rotation
			local MOMX = P_RandomRange(-2, 2) * FRACUNIT
			local MOMY = P_RandomRange(-2, 2) * FRACUNIT
			local MOMZ = P_RandomRange(5, 8) * FRACUNIT
			local POSITIONX = spring.x + (P_RandomRange(-30, 38)*FRACUNIT)
			local POSITIONY = spring.y + (P_RandomRange(-30, 38)*FRACUNIT)
			local POSITIONZ = spring.z+ (P_RandomRange(-5, 8)*FRACUNIT)
			local FUSE = (spring.angle/ANG1) - P_RandomRange(4, 15)
			local SCALE = FRACUNIT-(FRACUNIT/P_RandomRange(2, 5))
			local COLOR = ChooseAutumnColor()
			local ROTATION = P_RandomRange(5, 14) * ANG1

			local leaf = P_SpawnMobj(POSITIONX, POSITIONY, POSITIONZ, MT_LEAFDEBRIS)
			leaf.momx = MOMX
			leaf.momy = MOMY
			leaf.momz = MOMZ
			leaf.expire = FUSE
			leaf.scale = SCALE
			leaf.color = COLOR
			leaf.timer = 1
			leaf.transstate = 0
			leaf.rotation = ROTATION
			leaf.rotate = true
	end

	if season == "spring" and spring.state != S_INVISIBLE
		spring.state = S_INVISIBLE
		A_PlayActiveSound(spring)
	end
	
	if spring.state == S_INVISIBLE
		if not spring.SpawnedThem
			spring.flags = MF_NOGRAVITY
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			CreateLeaf()
			spring.SpawnedThem = true
		end
		
		if spring.respawn
			spring.timerz = $ + 1
			if (spring.timerz > mobjinfo[MT_AUTUMNSPRING].painchance*TICRATE)
				spring.Ready = true
				--print("ready")
			end
			
			if spring.Ready and season == "autumn"
				spring.state = S_AUTUMNSPRING
				spring.flags = spring.DefaultFlags
				spring.timerz = 0
				spring.SpawnedThem = false
				spring.Ready = false
				--print("change back")
			end
		else
			P_RemoveMobj(spring)
		end
	end

end, MT_AUTUMNSPRING)

addHook("MapThingSpawn", function(spring, mapthing)	
	spring.timerz = 0 
	
	if mapthing.options & MTF_EXTRA
		spring.respawn = true
		spring.timerz = 0
	end	
	
	if mapthing.options & MTF_AMBUSH
		spring.flags = $1 | MF_NOGRAVITY
	end
	
	spring.DefaultFlags = spring.flags
	
end, MT_AUTUMNSPRING)